"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var pick_1 = require("./pick");
var pipe_1 = require("./pipe");
var concat_1 = require("./concat");
describe('data first', function () {
    test('it should pick props', function () {
        var result = pick_1.pick({ a: 1, b: 2, c: 3, d: 4 }, ['a', 'd']);
        expect(result).toEqual({ a: 1, d: 4 });
    });
    test('allow undefined or null', function () {
        expect(pick_1.pick(undefined, ['foo'])).toEqual({});
        expect(pick_1.pick(null, ['foo'])).toEqual({});
    });
});
describe('data last', function () {
    test('it should pick props', function () {
        var result = pipe_1.pipe({ a: 1, b: 2, c: 3, d: 4 }, pick_1.pick(['a', 'd']));
        expect(result).toEqual({ a: 1, d: 4 });
    });
});
test('read only', function () {
    concat_1.concat([1, 2], [3, 4]);
    // or similar:
    // const props: ReadonlyArray<string> = ["prop1", "prop2"];
    // const getProps = <T extends string>(props: readonly T[]) => props;
    var someObject = { prop1: 'a', prop2: 2, a: 'b' };
    var props = ['prop1', 'prop2'];
    pick_1.pick(someObject, props); // TS2345 compilation error
});
