import { pick } from './pick';
import { pipe } from './pipe';
import { concat } from './concat';
describe('data first', function () {
    test('it should pick props', function () {
        var result = pick({ a: 1, b: 2, c: 3, d: 4 }, ['a', 'd']);
        expect(result).toEqual({ a: 1, d: 4 });
    });
    test('allow undefined or null', function () {
        expect(pick(undefined, ['foo'])).toEqual({});
        expect(pick(null, ['foo'])).toEqual({});
    });
});
describe('data last', function () {
    test('it should pick props', function () {
        var result = pipe({ a: 1, b: 2, c: 3, d: 4 }, pick(['a', 'd']));
        expect(result).toEqual({ a: 1, d: 4 });
    });
});
test('read only', function () {
    concat([1, 2], [3, 4]);
    // or similar:
    // const props: ReadonlyArray<string> = ["prop1", "prop2"];
    // const getProps = <T extends string>(props: readonly T[]) => props;
    var someObject = { prop1: 'a', prop2: 2, a: 'b' };
    var props = ['prop1', 'prop2'];
    pick(someObject, props); // TS2345 compilation error
});
